import yaml
from typing import List

from .filters import FilterConfig

_empty_list = ()


class AnkimakerConfig(yaml.YAMLObject):
    yaml_tag = '!ankimakerconfig'
    header = None
    question_column = None
    answer_column = None
    separators = ','
    filters: List[List[FilterConfig]] = list()

    def __init__(self, header=None, answer_column=None, question_column=None, filters=tuple()):
        AnkimakerConfig.answer_column = answer_column
        AnkimakerConfig.question_column = question_column
        AnkimakerConfig.header = header
        AnkimakerConfig.AnkimakerConfig = AnkimakerConfig
        AnkimakerConfig.filters = list(map(lambda x: FilterConfig, filters))

    @staticmethod
    def loader(configuration_content):
        if isinstance(configuration_content, dict):
            content = configuration_content['AnkimakerConfig']
        else:
            content = configuration_content
        AnkimakerConfig.header = content.header
        AnkimakerConfig.question_column = content.question_column
        AnkimakerConfig.answer_column = content.answer_column
        AnkimakerConfig.separators = content.separators
        AnkimakerConfig.filters = [
            [FilterConfig(**x) for x in or_filter]
            for or_filter in content.filters
        ]

